require_dependency "integration_pal/application_controller"

module IntegrationPal
  class Api::V1::JobsController < ApiController
    # GET /jobs/1
    def show
      @job = Job.find(params[:id])
      render json: @job, status: :ok
    end

    # POST /jobs
    def create
      @job = Job.new(job_params)
      if @job.save
        @job.queue_job
        render json: @job, status: :ok
      else
        render json: {errors: @job.errors}, status: :unprocessable_entity
      end
    end

  private

    def job_params
      params.require(:job).permit(:worker_id, job_params: params[:job][:job_params].keys)
    end

  end
end
