require_dependency "integration_pal/application_controller"

module IntegrationPal
  class ApiController < ApplicationController
    skip_before_action :authenticate!
    skip_before_action :verify_authenticity_token
    before_action :authenticate_api

  private

    def authenticate_api
      @worker = Worker.find_by_access_id(ApiAuth.access_id(request))
      head(:unauthorized) unless @worker && ApiAuth.authentic?(request, @worker.secret_key)
    end
  end
end
