module IntegrationPal
  class ApplicationController < ActionController::Base
    protect_from_forgery with: :exception
    before_action :authenticate!

    def authenticate!
      # pretend to be logged in; you can still go directly to /login if you want to test the SAML flow
      session[:saml_username] ||= ENV['USER'] if Rails.env.in?(%w(development test))
      redirect_to saml2_login_url unless logged_in?
    end

    def logged_in?
      session[:saml_username].present?
    end
    helper_method :logged_in?
  end
end
