module Canvas::Models
  class BaseModel
    include ::ActiveModel::Validations
    include ::ActiveModel::Serialization

    def initialize(attributes = {})
      attributes.each do |name, value|
        send("#{name}=", value)
      end

      after_initialize
    end

    def after_initialize
      # this method should be overwritten in subclass
    end

    def ==(other)
      to_json == other.to_json
    end
  end
end
