module Canvas::Models
  class Enrollment < BaseModel
    validates :user_sis_id, :role, presence: true
    validates :role, inclusion: {in:  ['student', 'teacher', 'ta', 'observer', 'designer', 'Pending Orientation']}
    validates :status, inclusion: {in:  %w(active deleted completed)}
    validate :course_or_section
    attr_accessor :course_sis_id, :user_sis_id, :role, :section_sis_id, :status, :associated_user_sis_id

    def course_or_section
      errors.add(:id, 'An enrollment must have either a course_id or a section_id') unless @course_sis_id || @section_sis_id
    end

    def after_initialize
      self.status ||= 'active'
    end
  end
end
