module IntegrationPal
  class InstallGenerator < Rails::Generators::Base
    source_root File.expand_path('../templates', __FILE__)

    desc "Mount the engine"
    def add_routes
      route "mount IntegrationPal::Engine, at: IntegrationPal::Engine.mounted_path"
    end

    desc "Add setup to ApplicationJob"
    def add_common_methods_to_application_job
      inject_into_file "#{Rails.root}/app/jobs/application_job.rb", after: "class ApplicationJob < ActiveJob::Base\n" do <<-'RUBY'
  include IntegrationPal::BaseJob
      RUBY
      end
    end

    desc "Add an initializer"
    def add_initializer
      initializer "integration_pal.rb" do
        content = <<-'RUBY'
# SAML XML Metadata files. Looked for in config/saml. Automatically looks for an existing *.erb version as well.
# IntegrationPal.saml_idp_metadata = 'idp_metadata.xml'
# IntegrationPal.saml_sp_metadata = 'sp_metadata.xml'
        RUBY
      end
    end

  end
end