module IntegrationPal
  class Engine < ::Rails::Engine
    require 'api-auth'
    require 'attr_encrypted'
    require 'jquery-rails'

    cattr_accessor :mounted_path

    config.autoload_once_paths += Dir["#{config.root}/lib/**/"]

    isolate_namespace IntegrationPal

    config.generators do |g|
      g.test_framework :rspec
      g.fixture_replacement :factory_girl, dir: 'spec/factories'
    end

    initializer :append_migrations do |app|
      unless app.root.to_s.match root.to_s
        config.paths["db/migrate"].expanded.each do |expanded_path|
          app.config.paths["db/migrate"] << expanded_path
        end
        ActiveRecord::Migrator.migrations_paths = Rails.application.paths['db/migrate'].to_a
      end
    end
  end
end
